import sys, os.path, string, tkMessageBox, array, math, time, shelve
sys.path.append(os.path.join(os.curdir,"lib"))
# Add the current folder path to the system path
PathList = sys.path
str_Path = os.path.join(os.path.dirname(sys.executable),'Seqself.DataSet\\OligoWords')
Flag = 1
for CurrPath in PathList:
    if str_Path == CurrPath:
        Flag = 0
if Flag == 1:
    sys.path.append(str_Path)
# print sys.path
sys.path[:0] = ['../../..']

class Main:
    def __init__(self):

        global task
        global frame
        global step
        global input_path
        global output_path
        global format

        self.argv = {'task':task,
                     'frame':frame,
                     'step':step,
                     'path':input_path,
                     'output':output_path,
                     'file':None,
                     'format':format,
                     'echo':'n'
                     }
                    

        self.StartTime = None
        self.DataSet = None
        self.wlength = 4

        # Validator
        self.validator = Validator()

        # CONSTANTS
        self.symbols = {'GC-content':' %;',
                        'G/C-skew':';',
                        'A/T-skew':';',
                        'Pattern deviation':' %;',
                        'Absolute deviation':' %;',
                        'Pattern skew':' %;',
                        'Variance':';'}

    # METHODS

    # Reset Dataser
    def reset(self):
        self.DataSet = {'Sequence name':'',
                        'Sequence link':'',
                        'Sequence description':'',
                        'Accession':'',
                        'Total sequence length':0,
                        'Locus length':0,
                        'Left border':0,
                        'Frame':0,
                        'Step':0,
                        'Time':'',
                        'GC-content':{},
                        'G/C-skew':{},
                        'A/T-skew':{},
                        'Pattern deviation':{},
                        'Pattern skew':{},
                        'Gene map':{},
                        'Variance':{},
                        }

    # process source data files
    def process(self):
        # make a copy of the argument dictionary
        argv = {}
        argv.update(self.argv)

        # validate settings
        result = self.validator.validateArguments(argv)
        if result:
            self.argv.update(result)
        else:
            return None

        # initiate object DataSet
        if self.argv['format'] == "b":
            self.reset()
        # get file list
        filelist = self.get_fileList(self.argv['path'])
        if len(filelist) == 0:
            return None
        if not os.path.exists(self.argv["output"]):
            os.makedirs(self.argv["output"])
        # run cicle for all files in the list
        outdata = ''
        print "Number of files to process: " + str(len(filelist))
        for fname in filelist:
            self.reset()
            try:
                output = self.get_output(fname)
            except:
                continue
            
            if self.argv['format'] == "t":
                self.savetxtfile(fname,output)
            else:
                self.savebinaryfile(fname)

    # return list of ".fst" files in the current directory
    def get_fileList(self,home_folder):
        extensions = ('GBK','FNA','FAS','FST','FASTA')
        l = os.listdir(home_folder)
        filelist = []
        for fname in l:
            if len(fname)>4 and string.upper(fname[-3:]) in extensions:
                filelist.append(os.path.join(home_folder,fname))
            else:
                continue
        filelist.sort()
        return filelist

    # return requested data table for the sequence in the given file
    def get_output(self, fname):
        if string.upper(fname[-3:]) == "GBK":
            seqname,seq = self.openGBK(fname)
        else:
            try:
                objFile = open(fname,"r")
            except:
                return None
            i = 1
            name = objFile.readline()
            if name[0] == '>':
                name = name[1:-1]
                # process sequence name
                name_components = string.split(name,"|")
                if len(name_components) == 5:
                    seqname = string.split(name_components[4],",")[0]
                    while seqname[0] == " ":
                        seqname = seqname[1:]
                    seqname = seqname + " " + string.split(name_components[3],".")[0]
                else:
                    seqname = name
                if seqname == "":
                    seqname = fname[:-4]
            else:
                print "File " + fname + " is not in FASTA format"
                return
            # retrieve output data as a text
            try:
                seq = objFile.read()
                seq = string.replace(seq,'\n','')
            except:
                seq = ''
            objFile.close()
        if len(seq) == 0:
            return None

        self.StartTime = time.clock()
        CurrTime = self.getCurrTime()
        print seqname
        seq = string.upper(seq)
        seqLen = len(seq)
        # dictionary of standard patterns
        StandardPatterns = {}
        if self.DataSet:
            self.DataSet['Time'] = CurrTime
            self.DataSet['Sequence name'] = seqname
            self.DataSet['Total sequence length'] = seqLen
            self.DataSet['Locus length'] = seqLen
            self.DataSet['Left border'] = 0
            self.DataSet['Frame'] = self.argv['frame']
            self.DataSet['Step'] = self.argv['step']
            output = ''
        else:
            output = ("# " + CurrTime + "\n# " +
                      seqname + "\n# Sequence length: " + str(len(seq)) + " bp.\n# Window: " + str(self.argv['frame']) +
                      "\tStep: " + str(self.argv['step']) + "\n#\n# Start\tStop\t")
        header = ''
        for task in self.argv['tasklist']:
            task['wlength'] = self.wlength
            taskId = task['ID']
            if len(taskId)>8 and string.find(taskId,"mer:")>0:
                pos = string.find(taskId,"mer:")-1
                if int(taskId[pos]) != task['wlength']:
                    taskId = taskId[:pos] + str(task['wlength']) + taskId[pos+1:]
            strSubtr = ' '
            if task['subtr']:
                strSubtr = '-' + task['subtr'] + "_" + str(task['wlength']) + "mer "
            if task['norm']:
                header += "n" + str(task['norm']) + "_" + str(task['wlength']) + "mer" + strSubtr
            header += self.validator.tasks[task['task']]
            StandardPatterns[taskId] = None
            if self.DataSet:
                self.DataSet[self.get_TaskCategory(task['task'])][taskId] = {}
                # maximal number of digits in coordinates
                maxnumlen = len(str(self.DataSet['Total sequence length']))
        if self.DataSet == None:
            output = output + header + "\n"
        start = 0
        stop = self.argv['frame']-1

        while stop <= seqLen+self.argv['frame']:
            if self.argv['echo'] == 'y':
                print [start,stop]
            if stop > len(seq):
                locus = seq[start:] + seq[:stop-len(seq)-1]
                output = output + str(start) + "\t" + str(stop-len(seq))
            else:
                locus = seq[start:stop]
                output = output + str(start) + "\t" + str(stop+1)
            for task in self.argv['tasklist']:
                if self.argv['echo'] == 'y':
                    print task
                taskId = task['ID']
                if len(taskId)>8 and string.find(taskId,"mer:")>0:
                    pos = string.find(taskId,"mer:")-1
                    if int(taskId[pos]) != task['wlength']:
                        taskId = taskId[:pos] + str(task['wlength']) + taskId[pos+1:]
                if self.argv['echo'] == 'y':
                    TaskStartTime = time.clock()
                # define a standard pattern for a new task
                if task['task'] in ("D","GD","GPS","GRPS","GRV","GV") and StandardPatterns[taskId] == None:
                    oStdPattern = Pattern(task['wlength'])
                    oStdPattern.setPattern(seq, task['norm'])
                    StandardPatterns[taskId] = oStdPattern
                value = self.get_value(locus,
                                       self.validator.tasks[task['task']],
                                       task['norm'],
                                       task['wlength'],
                                       task['subtr'],
                                       StandardPatterns[taskId])
                if self.DataSet:
                    try:
                        value = float(value)
                    except:
                        value = float(value[:-1])
                    taskCategory = self.get_TaskCategory(task['task'])
                    DataSet = {'value':value,
                               'start':start,
                               'stop':stop,
                               'symbol':self.symbols[taskCategory]}
                    key = (maxnumlen - len(str(start)))*" " + str(start)+'-'+str(stop)
                    self.DataSet[taskCategory][taskId][key] = DataSet
                else:
                    output = output + "\t" + value
            if self.DataSet == None:
                output = output + "\n"
            start = start + self.argv['step']
            stop = stop + self.argv['step']
            if self.argv['echo'] == 'y':
                print "has been done in " + str(time.clock() - TaskStartTime) + " sec."
                print
                
        print "has been done in " + str(time.clock() - self.StartTime) + " sec."
        print

        return output
        
    def openGBK(self, fname):
        file = open(fname,'r')
        line = "line"
        seqlendigits = 7
        gene = []
        ind = None
        CDS = None
        while line:
            line = file.readline()
            if (line == '' or line == '\n'):
                if CDS==1 and len(gene) == 6:
                    self.addGene(gene,seqlendigits)
                break
            elif line[:5] == 'LOCUS':
                self.DataSet['Accession'] = line[12:string.find(line," ",12)]
                seqlendigits = len(line[34:string.find(line," ",34)])
            elif line[:10] == 'DEFINITION':
                if string.find(string.upper(line),"PLASMID") > -1:
                    self.DataSet['Sequence description'] = "plasmid";
                else:
                    self.DataSet['Sequence description'] = "chromosome";
            elif line[:6] == 'SOURCE':
                source = line[12:-1]
                source = string.replace(source,"str. ","")
                source = string.replace(source," ","$")
                self.DataSet['Sequence name'] = source
            elif line[:11] == "     source":
                pos = string.rfind(line,".")
                if pos > 11:
                    seqlendigits = len(line)-pos-2
            elif line[5:8] == 'CDS':
                ind = None
                CDS = 1
                if len(gene) == 6:
                    self.addGene(gene,seqlendigits)
                    gene = []
                values = line[21:].split('.')
                if values[2][0] == ">" or values[2][0] == "<":
                    values[2] = values[2][1:]
                if values[0].find('complement') >= 0:
                    if values[0].find('join') >= 0:
                        try:
                            gene.append(int(values[0][16:]))
                        except:
                            try:
                                gene.append(int(values[0][17:]))
                            except:
                                print 'Error value fot int(): ' + values[0][17:]
                                return None
                        gene.append(int(values[len(values)-1][:-3]))
                        gene.append('rev')
                    else:   
                        try:
                            gene.append(int(values[0][11:]))
                        except:
                            try:
                                gene.append(int(values[0][12:]))
                            except:
                                print 'Error value fot int(): ' + values[0][12:]
                                return None
                        gene.append(int(values[2][:-2]))
                        gene.append('rev')
                elif values[0].find('join') >= 0:
                    try:
                        gene.append(int(values[0][5:]))
                    except:
                        try:
                            gene.append(int(values[0][6:]))
                        except:
                            print 'Error value fot int(): ' + values[0][6:]
                            return None
                    gene.append(int(values[len(values)-1][:-2]))
                    gene.append('dir')
                else:
                    try:
                        gene.append(int(values[0]))
                    except:
                        try:
                            gene.append(int(values[0][1:]))
                        except:
                            print 'Error value for int(): ' + values[0][1:]
                            return None
                    gene.append(int(values[2]))
                    gene.append('dir')
                for i in range(3):
                    gene.append('')
            elif line[21:22] == r"/" and CDS == 1:
                if line[21:27] == '/gene=' and len(gene) == 6:
                    ind = 3
                    gene[ind] = line[28:-1]
                    if gene[ind] != '' and  gene[ind][-1] == "\"":
                        gene[ind] = gene[ind][:-1]
                        ind = None
                elif line[21:30] == '/product=' and len(gene) == 6:
                    ind = 5
                    gene[ind] = line[31:-1]
                    if gene[ind] != '' and  gene[ind][-1] == "\"":
                        gene[ind] = gene[ind][:-1]
                        ind = None
                elif line[21:27] == '/note=' and len(gene) == 6:
                    ind = 4
                    gene[ind] = line[28:-1]
                    if gene[ind] != '' and gene[ind][-1] == "\"":
                        gene[ind] = gene[ind][:-1]
                        ind = None
                elif line[21:34] == '/translation=':
                    CDS = None
                else:
                    pass
            elif line[:6] == 'ORIGIN':
                ind = None
                if len(gene) == 6:
                    self.addGene(gene,seqlendigits)
                seq = file.read()
                for num in range(10):
                    seq = string.replace(seq,str(num),'')
                seq = string.replace(seq,' ','')
                seq = string.replace(seq,'//','')
                seq = string.replace(seq,'\n','')
                break
            else:
                if ind and CDS == 1:
                    gene[ind] = gene[ind] + " " + line[21:-1]
                    if gene[ind][-1] == "\"":
                        gene[ind] = gene[ind][:-1]
                        ind = None
                    
        file.close()
        return self.DataSet['Sequence name'],seq
    
    def addGene(self, gene, seqlendigits):
        subkeys = ('start','stop','direction','name','description','remark')
        key = (seqlendigits - len(str(gene[0])))*" " + str(gene[0]) + "-" + str(gene[1])
        self.DataSet["Gene map"][key] = {}
        for i in range(len(subkeys)):
            self.DataSet["Gene map"][key][subkeys[i]] = gene[i]

    def get_value(self, strSeq, mode, normalization, wlength, subtr, oStdPattern):
        # create a local pattern
        oCurrPattern = Pattern(wlength)
        oCurrPattern.setPattern(strSeq, normalization)
        oSubtrPattern = None
        if mode == 'GC-content':
            if len(strSeq) == 0:
                return 0
            GC = string.count(strSeq,'G') + string.count(strSeq,'C')
            return '%s' % (float(GC)/float(len(strSeq)))
        elif mode == 'G/C-skew':
            if len(strSeq) == 0:
                return 0
            G = string.count(strSeq,'G')
            C = string.count(strSeq,'C')
            return '%s' % (float(G-C)/float(G+C))
        elif mode == 'A/T-skew':
            if len(strSeq) == 0:
                return 0
            A = string.count(strSeq,'A')
            T = string.count(strSeq,'T')
            return '%s' % (float(A-T)/float(A+T))
        elif mode in ('Generalized distance',
                    'Generalized pattern skew',
                    'Generalized relative pattern skew',
                    'Generalized variance',
                    'Generalized relative variance') and normalization:
            oNormalizationTable = oStdPattern.getNormalizationTable()
            oCurrPattern.setNormalizationTable(oNormalizationTable)
        else:
            pass
        if subtr:
            s_normalization = int(subtr[1:])
            oSubtrPattern = Pattern(wlength)
            oSubtrPattern.setPattern(strSeq, s_normalization)
            
        if mode in ('Distance', 'Generalized distance'):
            distance = self.getPatternDistance(oCurrPattern, oStdPattern)
            s_distance = 0
            del oCurrPattern
            if oSubtrPattern:
                s_distance = self.getPatternDistance(oSubtrPattern, oStdPattern)
                del oSubtrPattern
            return '%s' % (distance-s_distance)
        
        elif mode in ('Pattern skew',
                      'Relative pattern skew',
                      'Generalized pattern skew',
                      'Generalized relative pattern skew'):
            PS = self.getOligoSkewness(oCurrPattern)
            del oCurrPattern
            s_PS = 0
            if oSubtrPattern:
                s_PS = self.getOligoSkewness(oSubtrPattern)
                del oSubtrPattern
            if mode in ('Pattern skew', 'Generalized pattern skew'):
                return '%s' % (PS-s_PS)
            else:
                ExpPS = self.get_expectedPS(len(strSeq))
                return '%s' % ((PS - ExpPS[0] - 2*s_PS)/(ExpPS[1]))
        
        elif mode in ('Variance',
                      'Generalized variance',
                      'Relative variance',
                      'Generalized relative variance'):
            oWordList = WordList(oCurrPattern.getWordLength())
            oWordList.setvalue(oCurrPattern)
            if mode in ('Variance','Generalized variance'):
                variance = oWordList.getVariance()
            else:
                variance = oWordList.getVariance(oCurrPattern)
            del oCurrPattern
            del oWordList
            s_variance = 0
            if oSubtrPattern:
                oWordList = WordList(oSubtrPattern.getWordLength())
                oWordList.setvalue(oSubtrPattern)
                if mode in ('Variance','Generalized variance'):
                    s_variance = oWordList.getVariance()
                else:
                    s_variance = oWordList.getVariance(oSubtrPattern)
                del oSubtrPattern
                del oWordList
            return '%s' % (variance-s_variance)
        
        else:
            print 'Error mode ' + mode
            return None
    
    def getPatternDistance(self, oCurrPattern, oStandardPattern):
        # get a word list for the standard pattern
        SWL = self.getWordList(oStandardPattern)
        SWL = SWL.getWordList()
        # get a word list for the current pattern
        CWL = self.getWordList(oCurrPattern)
        CWL = CWL.getWordList()
        # ranges the words in the standard and current patterns and sorts them alfabetically
        for wl in (SWL, CWL):
            wl = self.rankWordList(wl)
        wlength = oStandardPattern.getWordLength()
        return self.getDistance(SWL,CWL,wlength)
    
    def getOligoSkewness(self,oCurrPattern):
        # get a word list for the current pattern and its complemente
        CWL = self.getWordList(oCurrPattern)
        CWL = CWL.getWordList()
        CWL_compl = self.getComplement(CWL)
        # ranges the words in the standard and current patterns and sorts them alfabetically
        for wl in (CWL, CWL_compl):
            wl = self.rankWordList(wl)
        wlength = oCurrPattern.getWordLength()
        minDist = self.getStrandMinimalDistance(wlength)
        flg_BestHit = 0
        return self.getDistance(CWL,CWL_compl,wlength,flg_BestHit,minDist)

    # take pattern, standard list of words and mode, return ['word','pattern type'],
    # if take None, return current WordList
    def getWordList(self, oPattern):
        oWordList = WordList(oPattern.getWordLength())
        oWordList.setvalue(oPattern)
        return oWordList

    # wlist - list of word lists
    def rankWordList(self, wl):
        # ranges the words in the standard and current patterns and sorts them alfabetically
        wl.sort(self.sort_by_values)
        for j in range(len(wl)):
            # assigns ranges
            wl[j][3] = j
        # sort alfabetically
        wl.sort(self.sort_by_words)
        return wl
    
    def getDistance(self,wl1,wl2,wlength,flg_BestHit=1,MinDist=0):
        # set variables
        WordList1 = []
        WordList2 = []
        if len(wl1) == len(wl2) and len(wl1) > 0:
            for i in range(len(wl1)):
                WordList1.append([wl1[i][0],wl1[i][1],wl1[i][2],wl1[i][3]])
                WordList2.append([wl2[i][0],wl2[i][1],wl2[i][2],wl2[i][3]])
        else:
            return None
        if flg_BestHit == 1:
            WordList1_compl = self.getComplement(WordList1)
            WordList1_compl = self.rankWordList(WordList1_compl)
            WordList2_compl = self.getComplement(WordList2)
            WordList2_compl = self.rankWordList(WordList2_compl)
            sum2 = sum3 = sum4 = 0
            
        sum1 = 0
        # Calculate standard deviation and select strand if AutoComplement was checked
        WordNumber = 4**wlength
        for i in range(WordNumber):
            sum1 = sum1 + abs(WordList1[i][3]-WordList2[i][3])
            if flg_BestHit == 1:
                sum2 += abs(WordList1[i][3]-WordList2_compl[i][3])
                sum3 += abs(WordList1_compl[i][3]-WordList2[i][3])
                sum4 += abs(WordList1_compl[i][3]-WordList2_compl[i][3])
        if flg_BestHit == 1:
            Div = min(sum1,sum2,sum3,sum4)
        else:
            Div = sum1
        Div = 100.0*(Div - MinDist)/float((WordNumber*(WordNumber+1))/2.0 - MinDist)
        return Div

    # return minimal distance (pattern skew) between DNA strands
    def getStrandMinimalDistance(self, wlength):
        if wlength%2 == 0:
            return 4**wlength - 2**wlength
        else:
            return 4**wlength
        
    def getComplement(self, wl):
        WordList = []
        for item in wl:
            WordList.append([])
            for val in item:
                WordList[len(WordList)-1].append(val)
        WordList.sort(self.sort_by_order)
        WordDic = {}
        WordNumber = len(WordList)
        c = 1
        for i in range(WordNumber):
            WordDic[WordList[i][0]] = [WordList[i][0],WordList[i][1],WordList[i][2],WordList[i][3]]
        for i in range(WordNumber):
            arWord = array.array('c')
            arWord.fromstring(WordList[WordNumber-i-1][0])
            arWord.reverse()
            try:
                WordDic[arWord.tostring()][2] = WordList[i][2]
                WordDic[arWord.tostring()][3] = None
                del arWord
            except:
                c = c+1
        NewWordList = WordDic.values()
        del WordList
        del WordDic
        return NewWordList

    def get_expectedPS(self, seqLen):
        return [100-95.24*math.exp(-2796.6/seqLen),100-98.66*math.exp(-652.27/seqLen)]

    def get_TaskCategory(self, task):
        if task == "GC":
            return 'GC-content'
        elif task == "GCS":
            return 'G/C-skew'
        elif task == "ATS":
            return 'A/T-skew'
        elif task[-1:] == "D":
            return 'Pattern deviation'
        elif task[-1:] == "S":
            return 'Pattern skew'
        elif task[-1:] == "V":
            return 'Variance'
        else:
            pass
            
    def getCurrTime(self):
        CurrTime = time.localtime()
        CurrTime = (str(CurrTime[3]) + ":" + str(CurrTime[4]) + ":" + str(CurrTime[5]) + " " +
                str(CurrTime[2]) + "." + str(CurrTime[1]) + "." + str(CurrTime[0]))
        return CurrTime
    

    def converter(self):
        try:
            StrText = "<Sequence name> " + self.DataSet['Sequence name'] + " " + self.DataSet['Accession'] + "\n"
            StrText = StrText + "<Sequence description> " + self.DataSet['Sequence description'] + "\n"
            StrText = StrText + "<Total sequence length> " + str(self.DataSet['Total sequence length']) + "\n"
            StrText = StrText + "<Locus length> " + str(self.DataSet['Locus length']) + "\n"
            StrText = StrText + "<Left border> " + str(self.DataSet['Left border']) + "\n"
            StrText = StrText + "<Frame> " + str(self.DataSet['Frame']) + "\n"
            StrText = StrText + "<Step> " + str(self.DataSet['Step']) + "\n"
            for category in self.DataSet.keys():
                if category == "GC-content":
                    category_description = "G-C content"
                elif category == "G/C-skew":
                    category_description = "G-C Skew"
                elif category == "AT-content":
                    category_description = "A-T content"
                elif category == "A/T-skew":
                    category_description = "A-T Skew"
                elif category == 'Pattern deviation':
                    category_description = "Distance"
                else:
                    category_description = category
                if category not in ('Sequence name','Sequence description','Total sequence length','Locus length',
                                 'Left border','Frame','Step','Sequence link','Gene map','Time','Accession'):
                    for field in self.DataSet[category].keys():
                        StrText = StrText + "<Field> " + category_description + " [" + field + "]\n"
                        frames = self.DataSet[category][field].keys()
                        frames.sort()
                        for frame in frames:
                            lb,rb = string.split(frame,"-")
                            try:
                                value = str(self.DataSet[category][field][frame]['value'][0])
                            except:
                                value = str(self.DataSet[category][field][frame]['value'])
                            StrText = (StrText + str(self.DataSet[category][field][frame]['start']) + "\t" +
                                       str(self.DataSet[category][field][frame]['stop']) + "\t" +
                                       value + "\t" + self.DataSet[category][field][frame]['symbol'] + "\n")
                        StrText = StrText + "\n"
            if 'Gene map' in self.DataSet.keys() and self.DataSet['Gene map']:
                StrText = StrText + "<Gene map>\n"
                genes = self.DataSet['Gene map'].keys()
                genes.sort()
                for gene in genes:
                    colour = "red"
                    description = str(self.DataSet['Gene map'][gene]['name']) + str(self.DataSet['Gene map'][gene]['description']) + str(self.DataSet['Gene map'][gene]['remark'])
                    description = string.upper(description)
                    if string.find(description,"HYPOTHETICAL") > -1 or string.find(description,"UNKNOWN") > -1:
                        colour = "grey"
                    StrText = (StrText + "\"" + str(self.DataSet['Gene map'][gene]['name']) + "\"\t" +
                               str(self.DataSet['Gene map'][gene]['start']) + "\t" +
                               str(self.DataSet['Gene map'][gene]['stop']) + "\t\"" + 
                               str(self.DataSet['Gene map'][gene]['description']) + "\"\t\"" +
                               str(self.DataSet['Gene map'][gene]['remark']) + "\"\t" +
                               str(self.DataSet['Gene map'][gene]['direction']) + "\t" + colour + "\n")
            else:
                pass
            StrText = StrText[:-1]
            return StrText
        except:
            return None

    def savetxtfile(self,fname,outdata):
        if len(fname) > 4:
            outfilename = fname[:-3] + "out"
        else:
            outfilename = fname + ".out"
        outfilename = os.path.join(self.argv['output'],outfilename)
        outfile = open(outfilename,"w")
        outfile.write(outdata)
        outfile.close()
        outdata = ''

    def savebinaryfile(self,fname):
        outfilename = fname[:-3] + "mhh"
        fname = ''
        if self.DataSet['Sequence name']:
            fname += self.DataSet['Sequence name']
        if self.DataSet['Sequence description']:
            fname += "$"+self.DataSet['Sequence description']
        if self.DataSet['Accession']:
            fname += "$"+self.DataSet['Accession']
        if fname:
            for symb in ("/","\\",":","*","?","\"","<",">","|"):
                fname = string.replace(fname,symb,"-")
            outfilename = fname + ".mhh"
        #outfilename = os.path.join(self.argv['output'],outfilename)
        output = self.converter()
        if output:
            self.savetxtfile(outfilename,output)
        '''
        ofp = shelve.open(outfilename)
        ofp['mhh'] = self.DataSet
        ofp.close()
        '''

    # SORTING METHODS
    def sort_by_words(self, a, b):
        if a[0] < b[0]:
            return -1
        elif a[0] > b[0]:
            return 1
        return 0

    def sort_by_order(self, a, b):
        if b[1] < a[1]:
            return -1
        elif b[1] > a[1]:
            return 1
        return 0
    
    def sort_by_values(self, a, b):
        if b[2] < a[2]:
            return -1
        elif b[2] > a[2]:
            return 1
        else:
            if b[0] < a[0]:
                return -1
            elif b[0] > a[0]:
                return 1
            else:
                return 0
            

##############################################################################################################
class Validator:
    def __init__(self):
        pass
        # ATTRIBUTES
        self.MinimalLength = {
            7:295000,
            6:74000,
            5:18500,
            4:5000,
            3:1200,
            2:300
            }
        self.tasks = {'GC':'GC-content',
                      'GCS':'G/C-skew',
                      'ATS':'A/T-skew',
                      'D':'Distance',
                      'GD':'Generalized distance',
                      'PS':'Pattern skew',
                      'RPS':'Relative pattern skew',
                      'GPS':'Generalized pattern skew',
                      'GRPS':'Generalized relative pattern skew',
                      'V':'Variance',
                      'GV':'Generalized variance',
                      'RV':'Relative variance',
                      'GRV':'Generalized relative variance'}

    # METHODS
    def validateArguments(self, ArgList):
        ArgList['tasklist'] = []
        # check tasks
        Tasks = string.split(ArgList['task'],";")
        LengthLimits = []
        biggest_wlenth = 2
        for TaskId in Tasks:
            Values = string.split(TaskId,":")
            if len(Values) == 1:
                Values = [None,Values[0]]
            elif len(Values) == 2:
                pass
            else:
                showError("Wrong task: '" + str(TaskId) + "'.\nMust be like 'n0_4mer:D'")
                return None
            
            SuperTask = string.split(Values[1],'-')
            if len(SuperTask) > 2:
                showError("Wrong task: " + str(SuperTask) + "\nMust be " + str(self.tasks.keys()))
                return None
                
            Task = SuperTask[0]
            if len(SuperTask) == 2:
                Subtr = Values[0][:2]
                try:
                    n = int(Subtr[1:])
                except:
                    showError("Wrong setting for subtruction: " + str(Subtr) + "\nMust be in range n0...n7")
                    return None
                if Subtr[0] != 'n' or n > 7:
                    showError("Wrong setting for subtruction: " + str(Subtr) + "\nMust be in range n0...n7")
                    return None
                if n > biggest_wlenth:
                    biggest_wlenth = n
            else:
                Subtr = None
            if Task not in self.tasks.keys():
                showError("Wrong task: " + str(Task) + "\nMust be " + str(self.tasks.keys()))
                return None

            if Values[0]:
                Type = string.split(str(Values[0]),"_")
                if len(Type) != 2:
                    showError("Wrong type: " + str(Values[0]) + "\nMust be like 'n0_4mer'")
                    return None
                
                Norm = str(Type[0])
                if len(Norm) != 2 or Norm[0] != "n":
                    showError("Wrong type: " + str(Values[0]) + "\nMust be like 'n0_4mer'")
                    return None
                try:
                    Norm = int(Norm[1])
                except:
                    showError("Wrong type: " + str(Values[0]) + "\nMust be like 'n0_4mer'")
                    return None
                
                Wlength = str(Type[1])
                if len(Wlength) != 4 or Wlength[1:] != "mer":
                    showError("Wrong type: " + str(Values[0]) + "\nMust be like 'n0_4mer'")
                    return None
                try:
                    Wlength = int(Wlength[0])
                except:
                    showError("Wrong type: " + str(Values[0]) + "\nMust be like 'n0_4mer'")
                    return None
            else:
                Task = Values[1]
                Norm = None
                Wlength = 4
            
            # add task to the task list
            ArgList['tasklist'].append({'task':Task,'norm':Norm,'wlength':Wlength,'subtr':Subtr,'ID':TaskId})
            LengthLimits.append(self.get_MinimalLength(Wlength))

        # check frame sizes
        if ArgList['frame'] == None:
            ArgList['frame'] = min(LengthLimits)
        else:
            try:
              ArgList['frame'] = int(ArgList['frame'])
            except:
                showError("Wrong value for the sliding window size: " + str(ArgList['frame']))
                return None
            
        if ArgList['frame'] < min(LengthLimits):
            result = showError("The sliding window size must be at least " + str(min(LengthLimits)) + " bp.")
            return None
        else:
            pass

        # check step size
        if ArgList['step'] == None:
            ArgList['step'] = ArgList['frame']/2
        else:
            try:
              ArgList['step'] = int(ArgList['step'])
            except:
                showError("Wrong value for the step: " + str(ArgList['step']))
                return None

        if ArgList['step'] <= 0:
            result = showError("The step must be a positive integer.")
            return None
        elif ArgList['step'] > ArgList['frame']:
            showError("The step " + str("The step " + str(ArgList['step'])) + " bp should not be longe than the window.")
            return None
        else:
            pass

        # check path
        ArgList['path'] = os.path.join(ArgList['path'])
        if os.path.exists(ArgList['path']):
            pass
        else:
            showError("The path " + str(ArgList['path']) + " does not exist")
            return None

        # check format
        if ArgList['format'] not in ("t","b","bt","tb"):
            showError("Wrong file format " + str(ArgList['path']))
            return None
        elif string.find(ArgList['format'],"t") > -1:
            # in binary mode every output data are saved in a separate file
            ArgList['file'] = None
        else:
            pass

        return ArgList
    
    # ACCESSIONS
    def get_MinimalLength(self, n):
        return self.MinimalLength[n]

    def get_TaskCategory(self, task):
        return self.tasks[task]

###############################################################################################
class Pattern:
    def __init__(self,wlength):
        # ATTRIBUTES
            # Number of words in collection
        self.TotalWordNumber = 0
            # Word length
        self.wlength = wlength
            # Collection of words: word name like {'AAAA' : [real number, expected number, word spreading]}
            # Deviation is measured in values of expected standard deviation calculated by regression
            # equation for given word length and sequence length
        self.words = {}
            # AGCT-box
        self.boxAGCT = {'A':0,'G':0,'C':0,'T':0}
            # Type of normalization
        self.type = 0
            # object NormalizationTable
        self.oNormalizationTable = None
            # Number of segments
        self.segment = 1
            
        self.initiate()

    # METHODS
    # initiate words
    def initiate(self):
        # Fill in the generic pattern with words
        pmlib = PatternMethod()
        WordList = pmlib.getWordList(self.wlength)
        for i in range(len(WordList)):
            # word data [real,expected,regularity]
            self.words[WordList[i]] = [0,0,None]

    # Accession methods
    def setPattern(self, strSeq, normalization=0):
        # set mononucleotite matrix
        self.setMatrix(strSeq)
        # Calculate expected and real numbers of words: [real number, expected number]
        self.setWordStatistics(strSeq)
        # set normalization table and expected number of words
        if normalization:
            WordFrequencies = {}
            if normalization == 1:
                WordFrequencies.update(self.boxAGCT)
            else:
                oNormPattern = Pattern(normalization)
                oNormPattern.setPattern(strSeq)
                for word in oNormPattern.getWordList():
                    WordFrequencies[word] = oNormPattern.getWordFrequency(word)
                del oNormPattern
            oNormalizationTable = NormalizationTable(WordFrequencies)
            self.setNormalizationTable(oNormalizationTable)
            self.setPatternType(normalization)
        else:
            self.oNormalizationTable = None
            self.setExpectation()

    def setExpectation(self):
        wordlist = self.getWordList()
        pVal = float(len(wordlist)/self.TotalWordNumber)
        for word in wordlist:
            if self.oNormalizationTable:
                pVal = self.oNormalizationTable.getWordLikelihood(word)
            self.words[word][1] = pVal*self.TotalWordNumber
    
    def setMatrix(self, strSeq):
        # Calculate numbers of A, G, C and T in the sequence and assign values to the 4-cell table boxAGCT
        letters = self.boxAGCT.keys()
        for l in letters:
            self.boxAGCT[l] = float(string.count(strSeq,l))/len(strSeq)
        return 1

    def setWordStatistics(self, strSeq):
        keys = self.words.keys()
        badWords = ''
        # total number of words
        self.TotalWordNumber = len(strSeq) - self.wlength
        # real number of words
        WordPosition = {}
        for i in range(self.TotalWordNumber):
            word = strSeq[i:i+self.wlength]
            try:
                self.words[word][0] = self.words[word][0] + 1
                # set statistics for word spreading
                if self.words[word][2]:
                    distance = i - WordPosition[word]
                    WordPosition[word] = i
                    self.words[word][2]['Sum 1'] = self.words[word][2]['Sum 1'] + distance
                    self.words[word][2]['Sum 2'] = self.words[word][2]['Sum 2'] + distance*distance
                else:
                    WordPosition[word] = i
                    self.words[word][2] = {'Sum 1':0,'Sum 2':0,'Start':i}
            except:
                if string.find(word,'*') == -1:
                    badWords = badWords + word + '; '
        return badWords
            
    def getWordLength(self):
        return self.wlength

    def getSeqLength(self):
        return self.TotalWordNumber + self.wlength

    def getWordList(self):
        return self.words.keys()

    def getRealNumber(self, word):
        return self.words[word][0]

    def getNormalizedValue(self, word):
        return self.words[word][1]

    def setNormalizationType(self, val):
        self.NormalizationType = val

    def getNormalizationTable(self):
        return self.oNormalizationTable

    def setNormalizationTable(self, oNormalizationTable):
        del self.oNormalizationTable
        self.oNormalizationTable = oNormalizationTable
        self.setExpectation()

    # pattern (normalization) types: 0, 1, 2 ...
    def setPatternType(self, type):
        self.type = type

    def getPatternType(self):
        return self.type

    def getRegularity(self, word):
        N = self.words[word][0]-1
        if self.words[word][2] == None:
            return ''
        elif N <= 2:
            Mean = 0
            StdDev = 0
            k = 0
        else:
            Sum1 = self.words[word][2]['Sum 1']
            Sum2 = self.words[word][2]['Sum 2']
            Mean = Sum1/N
            StdDev = math.sqrt((Sum2 - Sum1*Sum1/N)/(N - 1))
            k = math.sqrt(2*N)*(Mean-StdDev)/Mean
        return str(Mean) + "\t" + str(StdDev) + "\t" + str(k) + "\n"

    def getMeanWordNumber(self):
        return self.TotalWordNumber/len(self.words.keys())

    def getNucleotideFrequency(self,letter):
        return self.boxAGCT[letter]
    
    def getWordFrequency(self, word):
        return float(self.words[word][0])/float(self.TotalWordNumber)

    def getAGCT_proportions(self):
        boxAGCT = {}
        seqLen = self.getSeqLength()
        for l in self.boxAGCT.keys():
            print self.boxAGCT[l]
            if self.boxAGCT[l] < 1:
                boxAGCT[l] = int(self.boxAGCT[l]*seqLen)
            else:
                boxAGCT[l].update(self.boxAGCT[l])
        return boxAGCT

    def has_regularity(self):
        wl = self.getWordList()
        if len(wl) > 0:
            return self.words[wl[0]][2]
        else:
            return None

    # return a copy of the current pattern object
    def copy(self):
        oPattern = Pattern(self.wlength)
        oPattern.TotalWordNumber = self.TotalWordNumber
        oPattern.wlength = self.wlength
        oPattern.words = self.words
        oPattern.boxAGCT = self.boxAGCT
        try:
            oPattern.segment = self.segment
        except:
            oPattern.segment = 1
        try:
            oPattern.NormalizationType = self.NormalizationType
        except:
            oPattern.NormalizationType = None
        return oPattern
    
    def __add__(self,other):
        if self.wlength != other.wlength:
            print 'first: ' + str(self.wlength)
            print 'second: ' + str(other.wlength)
            print 'Error in Pattern.__add__()'
            return None
        result = Pattern(self.wlength)
        # set normalization type
        result.NormalizationType = self.NormalizationType
        # sum and recalculate values
        result.TotalWordNumber = self.TotalWordNumber + other.TotalWordNumber
        for w in self.words.keys():
            # sum real and expected word numbers
            result.words[w] = [0,0,None]
            result.words[w][0] = self.words[w][0] + other.words[w][0]
            result.words[w][1] = self.words[w][1] + other.words[w][1]
        for l in ['A','G','C','T']:
            result.boxAGCT[l] = (self.boxAGCT[l]*(self.TotalWordNumber + self.wlength) +
                                 other.boxAGCT[l]*(other.TotalWordNumber + other.wlength))/(result.TotalWordNumber +
                                                                                            result.wlength)
        return result

    # Sorting methods
    def sort_by_ranks(self, a, b):
        if a[0] > b[0]:
            return 1
        elif a[0] < b[0]:
            return -1
        else:
            return 0

###################################################################################################################
class WordList:
    def __init__(self,wlength):

        # ATTRIBUTES
        self.wlength = wlength
        self.wordList = []
        # Create library of pattern setting methods
        pmlib = PatternMethod()
        # Create list and dictionary of the words
        for i in range(4**self.wlength):
            word = pmlib.getNextWord(self.wlength)
            CurrWord = ['',0,0,None]
            CurrWord[0] = word
            CurrWord[1] = i
            self.wordList.append(CurrWord)

    # METHODS
    def setvalue(self, oPattern):
        normal_expect = oPattern.getMeanWordNumber()
        normstdiv = self.get_NormStDiv(oPattern.getWordLength(),oPattern.getSeqLength())
        for item in self.wordList:
            value = oPattern.getRealNumber(item[0])
            # set word frequencies
            item[3] = oPattern.getWordFrequency(item[0])
            if oPattern.getPatternType():
                # normalized patterns
                # expected number of word
                expect = oPattern.getNormalizedValue(item[0])
                # correction for the letter inequivalence
                if expect == 0:
                    expect = 1
                item[2] = float((value - expect)/normal_expect)/normstdiv
            else:
                item[2] = float(value - normal_expect)/normal_expect/normstdiv
        return 1

    def getWordList(self):
        return self.wordList

    def getLength(self):
        return len(self.wordList)

    def getVariance(self,oPattern=None):
        sum = 0
        sum_sq = 0
        N = len(self.wordList)
        for i in range(N):
            sum = sum + self.wordList[i][2]
            sum_sq = sum_sq + self.wordList[i][2] * self.wordList[i][2]
        var = (sum_sq - sum * sum/N)/(N - 1)
        return var

    def get_NormStDiv(self, word_length, seq_length):
        return math.sqrt(0.02+(4**word_length)/seq_length)

##############################################################################################################
class PatternMethod:
    def __init__(self, method="BOXAGCT"):
            # Method
        self.CurrMethod = method
            # Current word
        self.Word = ""
            # The letter of the word in focus
        self.Cursor = None
            # State of the word processing by any function
        self.flg_State = 0
            # Dictionary of methods of oligomer plot arrangment
        self.Methods = {}
            # Dictionary of letter functions 
        self.LetterFunk = {}
        
        self.setDictionary()

    # Methods
        # Block of functions for method BOXAGCT
    def A_BOXAGCT(self):
        self.changeLetters("G","C",self.Cursor)
        self.flg_State = 0       

    def G_BOXAGCT(self):
        self.changeLetters("A","C",self.Cursor)
        if self.Cursor >= 0:
            self.Cursor = self.Cursor - 1
        else:
            self.flg_State = 0
            
    def C_BOXAGCT(self):
        self.changeLetters("T","A",self.Cursor)
        if self.Cursor >= 0:
            self.flg_State = 0
        else:
            self.Cursor = self.Cursor - 1

    def T_BOXAGCT(self):
        self.changeLetters("C","A",self.Cursor)
        self.Cursor = self.Cursor - 1
 
    def changeLetters(self, a, b, position):
        if position >= 0:
            self.Word = self.Word[:position] + a + self.Word[(position+1):]
        else:
            if position == -1:
                self.Word = self.Word[:position] + b + self.Word[:(position+1)]
            else:
                self.Word = self.Word[:position] + b + self.Word[(position+1):]

    def setDictionary(self):
        # initialisation of dictionary of functions for method BOXAGCT
        self.LetterFunk["A"] = self.A_BOXAGCT
        self.LetterFunk["G"] = self.G_BOXAGCT
        self.LetterFunk["C"] = self.C_BOXAGCT
        self.LetterFunk["T"] = self.T_BOXAGCT
        self.Methods["BOXAGCT"] = self.LetterFunk

    def getNextWord(self, wlength):
        if self.Word == '':
            self.Word = "A"*wlength
        else:
            # create new word
            self.Cursor = wlength - 1
            self.flg_State = 1
            while self.flg_State == 1:
                self.Methods[self.CurrMethod][self.Word[self.Cursor]]()
        return self.Word

    def getWordList(self, wlength):
        if wlength != 0:
            self.Word = ''
            wordList = []
            for i in range(4**wlength):
                wordList.append(self.getNextWord(wlength))
            return wordList

###################################################################################################################
# words is a dictionary {'word':frequency}
class NormalizationTable:
    def __init__(self, words):
        
        # ATTRIBUTES
        self.words = words

    # METHODS

    def getWordLikelihood(self, word):
        frame = len(self.words.keys()[0])
        pVal = self.words[word[:frame]]
        subword = word[1:frame]
        subset = self.setSubset(subword)
        start = 1
        stop = frame+1
        while stop <= len(word):
            pVal = pVal * subset[word[start:stop]]
            start = start + 1
            subword = word[start:stop]
            subset = self.setSubset(subword)
            stop = stop + 1
        return pVal

    def setSubset(self, subword):
        subset = {}
        wordlist = self.words.keys()
        TotalLikelihood = 0
        for word in wordlist:
            if subword == word[:len(subword)]:
                subset[word] = self.words[word]
                TotalLikelihood = TotalLikelihood + subset[word]
        SubSet = {}
        SubSet.update(subset)
        keys = SubSet.keys()
        for key in keys:
            if TotalLikelihood:
                SubSet[key] = SubSet[key]/TotalLikelihood
            else:
                SubSet[key] = 0
        return SubSet

###################################################################################################################
# GLOBAL FUNCTIONS
# Get list of values and return [mean value,standard deviation]

def getMeanAndStDev(DataList):
    sum = 0
    sum_sq = 0
    N = len(DataList)
    for i in range(N):
        sum = sum + DataList[i]
        sum_sq = sum_sq + DataList[i] * DataList[i]
    val = (sum_sq - sum * sum/N)/(N - 1)
    stdev = math.sqrt(val)
    mean = sum/N
    return [mean,stdev]
    
def showError(message):
    print ("Error! " + str(message))
    
    
def edit_tasklist():
    a = A = "A"
    r = R = "R"
    q = Q = "Q"
    response = ""
    while response != "Q":
        print
        print "Edit task list"
        print
        print "  A   add a new task to the list;"
        print "  R   remove a task from the list;"
        print "  Q   quit;"
        try:
            response = raw_input("?")
        except:
            continue
        response = string.upper(str(response))
        if response == "A":
            add_task()
        elif response == "R":
            remove_task()
        else:
            continue

def add_task():
    global task
    c = C = "C"
    n = N = "N"
    w = W = "W"
    a = A = "A"
    q = Q = "Q"
    task_code = "D"
    wlength = 4
    norm = 1
    task_categories = {"GC":"GC-content",
                        "AT":"AT-content",
                        "GCS":"GC-skew",
                        "ATS":"AT-skew",
                        "D":"pattern deviation",
                        "GD":"generalized pattern deviation",
                        "PS":"pattern skew",
                        "GPS":"generalized pattern skew",
                        "RV":"relative variance",
                        "GRV":"generalized relative variance"}
    response = ""
    while response != "Q":
        print
        print "Add a task"
        print
        print "  C   task category:\t\t" + task_code + " (" + task_categories[task_code] + ")"
        print "  W   word length:\t\t" + str(wlength)
        print "  N   normalization:\t\t" + str(norm)
        print "  A   add task to the list"
        print "  Q   quit;"
        try:
            response = raw_input("?")
        except:
            continue
        response = string.upper(response)
        if response == "C":
            new_task = select_task(task_categories)
            if new_task:
                task_code = new_task
        elif response == "W":
            val = input("Enter the length of the words in range from 2 to 7 ")
            try:
                val = int(val)
                if val > 1 and val < 8:
                    wlength = val
            except:
                print
                print "Word length must be an integer in range from 2 to 7"
                print
                continue
        elif response == "N":
            val = input("Enter the normalization value in range from 0 to word_length - 1 ")
            try:
                val = int(val)
                if val >= 0 and val < wlength:
                    norm = val
            except:
                print
                print "Word length must be an integer in range from 0 to word_length - 1"
                print
                continue
        elif response == "A":
            if task_code in ("GC","AT","GCS","ATS"):
                new_task = task_code
            else:
                new_task = "n" + str(norm) + "_" + str(wlength) + "mer:" + task_code
            if new_task not in string.split(task,";"):
                if len(task):
                    task += ";" + new_task
                else:
                    task = new_task
            print
            print "Task " + string.split(task,";")[-1] + " was added successfully"
            print
        else:
            continue

def remove_task():
    global task
    index = None
    while index != 0:
        tasklist = string.split(task,";")
        print
        print "Remove task from the list"
        print
        print "  0   escape;"
        for i in range(len(tasklist)):
            print "  " + str(i+1) + "   " + tasklist[i]
        print
        index = input("Select the task by its index: ")
        try:
            index = int(index)
            if index > 0 and index <= len(tasklist):
                task = ""
                for j in range(len(tasklist)):
                    if j != index-1:
                        task += tasklist[j] + ";"
                if len(task):
                    task = task[:-1]
            elif index != 0:
                print
                print "\tWrong task index"
                print
            else:
                return
        except:
            print
            print "\tEnter an integer from 0 to " + str(len(tasklist))
            print
            continue
        
def select_task(task_categories):
    index = None
    while index != 0:
        codes = []
        count = 1
        print
        print "Select task category"
        print
        print "  0   escape;"
        for task_code in task_categories.keys():
            print "  " + str(count) + "   " + task_code + " (" + task_categories[task_code] + ");"
            codes.append(task_code)
            count += 1
        print
        index = input("Select the task category by its index: ")
        try:
            index = int(index)
            if index > 0 and index <= len(codes):
                return codes[index-1]
            elif index != 0:
                print
                print "\tWrong category index"
                print
            else:
                break
        except:
            print
            print "\tEnter an integer from 0 to " + str(len(codes))
            print
            continue
    return None

if __name__ == "__main__":

    global task
    task = 'GC;GCS;n0_4mer:D;n0_4mer:PS;n1_4mer:RV;n1_4mer:GRV'
    global frame
    frame = 8000
    global step
    step = 2000
    global input_path
    input_path = "input"
    global output_path
    output_path = "output"
    global format
    format = "b"

    t = T = "T"
    l = L = "L"
    s = S = "S"
    i = I = "I"
    o = O = "O"
    #f = F = "F"
    y = Y = "Y"
    q = Q = "Q"


    # Terminal interface
    response = ''
    while response != "Q":
        if format == "t":
            format_text = "text"
        else:
            format_text = "binary MHH"

        print "OligoWord 1.2.1"
        print
        print "Settings for this run:\n\t\t\t\t\tTask list:"
        tasks = string.split(task,";")
        print "  T   Tasks to perform?\t\t\t: " + tasks[0]
        if len(tasks) > 1:
            for tn in range(1,len(tasks)):
                print "\t\t\t\t\t: " + tasks[tn]
            print
        print "  L   Length of the sliding window?\t: " + str(frame) + " bp."
        print "  S   Step of the sliding window?\t: " + str(step) + " bp."
        print "  I   Input folder?\t\t\t: " + input_path
        print "  O   Output folder?\t\t\t: " + output_path
        print "  Q   to quit"
        print
        print "Y to accept these settings, type the letter for one to change or Q to quit"
        try:
            response = raw_input("?")
        except:
            continue
        response = string.upper(response)
        if response in ("Y","L","T","O","I","S"):
            if response == "Y":
                print
                MainWin = Main()
                MainWin.process()
                del MainWin
                continue
            elif response == "T":
                edit_tasklist()
            elif response == "L":
                val = input("Length of sliding window? ")
                try:
                    frame = int(val)
                except:
                    print "Length of the sliding window must be an integer!"
                    print
                    continue
            elif response == "S":
                val = input("Step of the sliding window? ")
                try:
                    step = int(val)
                except:
                    print "Step of the sliding window must be an integer!"
                    print
                    continue
            elif response == "I":
                folder = raw_input("Input folder? ")
                if not os.path.exists(folder):
                    print "Folder " + folder + " doesn't exist!"
                    print
                    continue
                input_path = folder
            elif response == "O":
                folder = raw_input("Output folder? ")
                for symbol in ("\\","/","|","<",">","*",":","\"","?"):
                    if string.find(folder,symbol)>-1:
                        print "Folder name must not containe symbol " + symbol
                        print
                        continue
                output_path = folder
            else:
                continue
            '''
            elif response == "F":
                if format == "t":
                    format = "b"
                else:
                    format = "t"
            '''

